#/bin/bash
set -eu -o pipefail # See: https://sipb.mit.edu/doc/safe-shell/

# macOS find doesn't have -printf so maybe can "find . ... -print"
find $PWD \( -path '*/generated' -prune -or -path '*/.git' -prune \) -or \
    -regex ".*\.[hcHC]\(pp\|xx\)?" -type f -printf '%P\n' > cscope.files

# -b = Build database.
# -q = Enable fast symbol lookup via an inverted index.
# -R = (Instead of using cscope.files) Recurse subdirectories.
# -k = Kernel mode. (Ignore /usr/include)
cscope -q -b -k

echo "You can now use \`cscope -d\`  # Run cscope without updating cross reference"
