#/bin/bash
set -eu -o pipefail # See: https://sipb.mit.edu/doc/safe-shell/

# Add flag --c++-kinds=+p for tags to declaration in .h files too.
ctags -n --if0=yes --langmap=c++:+.inl -R --extra=q \
    --exclude=.git \
    --exclude=obj \
    --exclude=lib \
    --exclude='*generated/*'

find . -mindepth 1 \
        -path './.git' -prune \
    -or -path './include' -prune \
    -or -path './lib' -prune \
    -or -path '*/obj' -prune \
    -or -path '*/generated' -prune \
    -or -type d -print | while read i
do
    pushd "$i" 1> /dev/null
    ctags -n --if0=yes --langmap=c++:+.inl -R --extra=q \
        --exclude=obj \
        --exclude='*generated/*'
    popd 1> /dev/null
done

# Finally, there'll be empty tags files, unlink those
find . -name tags -size -2 -mtime -1 -delete
